;*****************************************************************************
;  ணࠬ 樠樨 EVM   CS4215                                *
;*****************************************************************************



;*****************************************************************************
;       ⠭                                                            *
;*****************************************************************************
PCD             equ     $FFE5   ;  - ॣ   
PCDDR           equ     $FFE3   ;⠬  ॣ ࠢ   
PCC             equ     $FFE1   ;⠬  ஫쭮 ॣ  
PBC             equ     $FFE0   ;⠬  ஫쭮 ॣ 設  
CRA             equ     $FFEC   ;⠬  ஫쭮 ॣ 
CRB             equ     $FFED   ;⠬  ஫쭮 ॣ 
SSIDR           equ     $FFEF   ;⠬  SSI ॣ ਥ/। 
IPR             equ     $FFFF   ;⠬  ॣ ஢ ࠧ襭 뢠
BCR             equ     $FFFE   ;⠬  ஫쭮 ॣ 設  
SSISR           equ     $FFEE   ;⠬  ॣ SSIﭨ/६. ࢠ
PLL             equ     $FFFD   ;⠬  PLL ॣ
;*****************************************************************************
;        ६ ࢠ
;*****************************************************************************
NO_PREAMP       equ     $100000         ;஢ 室 (MLB ) 0-䮭
LO_OUT_DRV      equ     $080000         ; 室 (OLB )
;*****************************************************************************
;       ன ६ ࢠ
;*****************************************************************************
HI_PASS_FILT    equ     $008000         ;祭  䨫  ࠡ 
                                        ;䮭 ( DC ᬥ饭)
SAMP_RATE_9     equ     $003800         ;Fd=9.6
SAMP_RATE_48    equ     $003000         ;Fd=48
SAMP_RATE_32    equ     $001800         ;Fd=32
SAMP_RATE_27    equ     $001000         ;Fd=27.4
SAMP_RATE_16    equ     $000800         ;Fd=16
SAMP_RATE_8     equ     $000000         ;Fd=8
STEREO          equ     $000400         ;८  (0 - )
DATA_8LIN       equ     $000300         ;8   
DATA_8A         equ     $000200         ;8  -
DATA_8U         equ     $000100         ;8  -
DATA_16         equ     $000000         ;16   
;*****************************************************************************
;       ⨩ ६ ࢠ
;*****************************************************************************
IMMED_3STATE    equ     $800000         ; 室  3 ﭨ
XTAL2_SELECT    equ     $200000         ;롮  XTAL2=16.9344 
BITS_64         equ     $000000         ;64   
BITS_128        equ     $040000         ;128   
BITS_256        equ     $080000         ;256   
CODEC_MASTER    equ     $020000         ; SCLK  FSYNC
CODEC_TX_OFF    equ     $010000         ; 뢮 
;*****************************************************************************
;       ⢥-쬮 ६ ࢠ  ᮤঠ ⠭           *
;                                                                            *
;       ଠ ஫ ᫮:                                             *
;       CTRL_WD_xx ⮨  2 ᫮: 訥 8    ᫮   *
;       ᫥騥 8  - ,  8     ଠ樨  *
;           뫠                                              *
;*****************************************************************************
CTRL_WD_12      equ     $200000+NO_PREAMP+HI_PASS_FILT+SAMP_RATE_8+DATA_16
CTRL_WD_34      equ     IMMED_3STATE+XTAL2_SELECT+BITS_64+CODEC_MASTER
CTRL_WD_56      equ     $000000
CTRL_WD_78      equ     $000000
;*****************************************************************************
;       ஫ ࠬ  ଠ쭮 ࠡ .                  *
;        5-8 ६ ࢠ  ० ਥ।       *
;*****************************************************************************
;        ६ ࢠ                                             *
;*****************************************************************************
HEADPHONE_EN    equ     $800000         ;ࠧ襭 뢮  譨
LINEOUT_EN      equ     $400000         ;ࠧ襭  뢮
LEFT_ATTN       equ     $010000         ;. ᫠: 63*LEFT_ATTN=-94.5,
                                        ;0*LEFT_ATTN=0 , 蠣 1.5 
;*****************************************************************************
;       ⮩ ६ ࢠ                                            *
;*****************************************************************************
SPEAKER_EN      equ     $004000         ;ࠧ襭 ᯨ
RIGHT_ATTN      equ     $000100         ;.᫠: 63*RIGHT_ATTN=-94.5,
                                        ;0*RIGHT_ATTN=0 , 蠣 1.5 
;*****************************************************************************
;       쬮 ६ ࢠ                                           *
;*****************************************************************************
MIC_IN_SELECT   equ     $100000         ;0 -  室, 1*... - 䮭
LEFT_GAIN       equ     $010000         ;.ᨫ 15*LEFT_GAIN=22.5 ,
                                        ;0*LEFT_GAIN=0 , 蠣 1.5 
;*****************************************************************************
;       쬮 ६ ࢠ                                           *
;*****************************************************************************
MONITOR_ATTN    equ     $001000         ;祭 . 裡: 15*... - 몫.
                                        ;0 - ., 蠣 6 
RIGHT_GAIN      equ     $000100         ;.ᨫ 15*RIGHT_GAIN=22.5 ,
                                        ;0*RIGHT_GAIN=0 , 蠣 1.5 
;*****************************************************************************
;       ਬ 祭 5_6  7_8 ᫮                                    *
;*****************************************************************************
OUTPUT_SET      equ     HEADPHONE_EN+LINEOUT_EN+(LEFT_ATTN*4)
INPUT_SET       equ     MIC_IN_SELECT+(15*MONITOR_ATTN)+(RIGHT_ATTN*4)
;*****************************************************************************
;        ஢ 뢠                                          *
;*****************************************************************************
        org     p:0                     ; ᨣ 
reset   jmp     init                    ; ணࠬ 樠樨
stack   nop                             ;訡 ⥪
        nop                             ;
trace   nop                             ;뢠 ஢
        nop                             ;
swi     nop                             ;ணࠬ 뢠
        nop                             ;
irqa    nop                             ;譥  IRQA
        nop                             ;
irqb    nop                             ;譥  IRQB
        nop                             ;
ssir    jsr     ssi_receive_isr         ; 㯫 뢠 ਥ
                                        ;믮 楤 ssi_receive
ssirwe  jsr     ssi_receive_isr         ;   ᪫. 뢠 ਥ
ssit    jsr     ssi_transmit_isr        ; 㯫 뢠 ।
                                        ;믮 楤 ssi_transmit
ssitwe  jsr     ssi_transmit_isr        ;   ᪫. 뢠 ।
scir    nop                             ;뢠 ਥ  . 䥩
scirwe  nop                             ;   ᪫. 
scit    nop                             ;뢠 ।  . .
scidle  nop                             ;뢠  . .
scitim  nop                             ;뢠 ⠩ . .
nmi     nop                             ;᪨㥬 뢠
hostr   nop                             ; 뢠 ਥ
hostt   nop                             ; 뢠 ।
hostcom nop                             ;  뢠
                                        ; 12   뢠
        org     p:$3e                   ;
ill     nop                             ;뢠  믮
        nop                             ;쭮 樨
;*****************************************************************************
;       ࣠ ஢  -                                       *
;*****************************************************************************
        org    x:0
RXBUFFER        equ     *               ;⪠ 砫  ਥ
                                        ;祩 :
RX12            ds      1               ; ६ ࢠ 1  2
RX34            ds      1               ; ६ ࢠ 1  2
RX56            ds      1               ; ६ ࢠ 1  2
RX78            ds      1               ; ६ ࢠ 1  2

TXBUFFER        equ     *               ;⪠ 砫  ।
                                        ;祩 :
TX12            ds      1               ; ६ ࢠ 1  2
TX34            ds      1               ; ६ ࢠ 1  2
TX56            ds      1               ; ६ ࢠ 1  2
TX78            ds      1               ; ६ ࢠ 1  2

RXPTR           ds      1               ;祩   㪠⥫ 
                                        ;⥪騩   ਥ
TXPTR           ds      1               ;祩   㪠⥫ 
                                        ;⥪騩   ।
;*****************************************************************************
;       ணࠬ 樠樨                                              *
;*****************************************************************************
        org     p:$40
init    ori     #3,mr                   ;  뢠
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   ﭨ  SR                                         ;;
;;  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+                       ;;
;;  |15|14|13|12|11|10| 9| 8| 7| 6| 5| 4| 3| 2| 1| 0|                       ;;
;;  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+                       ;;
;;  |LF|**| T|**|S1|S0|I1|I0|**| L| E| U| N| Z| V| C|                       ;;
;;  +-----------------------+-----------------------+                       ;;
;;  |          MR           |          CCR          |                       ;;
;;  +-----------------------+-----------------------+                       ;;
;;  MR    - ॣ ०                                                  ;;
;;  CCR   - ॣ ᫮                                           ;;
;;  **    - १ࢨ஢                                                 ;;
;;  LF    - 䫠 ⨢ 樨 DO                                     ;;
;;   T    - 䫠 ० ஢                                         ;;
;;  S1-S0 - ० ⠡஢                                           ;;
;;  I1-I0 - ᪠ 뢠: 11-  ᪨㥬 뢠         ;;
;;  L, E, U, N, Z, V, C - 䫠 ࠭祭, ७,                    ;;
;;                      ଠ, ⥫쭮, ,         ;;
;;                      ९, ७                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        movep   #$261009,x:PLL          ;⠭ 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   PLL() ᠭ                                                     ;;
;;+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+ ;;
;;|23|22|21|20|19|18|17|16|15|14|13|12|11|10| 9| 8| 7| 6| 5| 4| 3| 2| 1| 0| ;;
;;+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+ ;;
;;  0  0  1  0  0  1  1  0  0  0  0  1  0  0  0  0  0  0  0  0  1  0  0  1  ;;
;; 23(reserve)          - १ࢨ஢ (ᥣ 0)                         ;;
;; 22(CKOS)             - 室 CKOUT clock   VCO(1)   LPD(0);;
;; 21(CSRC)             - CLOCK  ⠫  :VCO(1);LPD(0)      ;;
;; 20-19(COD1-COD0)     - ॣ㫨஢ CKOUT  (00 -  )      ;;
;; 18(PEN)              - PLL enable  (1 - ࠧ襭, 0 - 饭)       ;;
;; 17(PSTR)             - ஫ 室  STOP ﭨ(1 - )    ;;
;; 16(XTLD)             - onchip XTAL ࠧ襭(0) (1)               ;;
;; 15-12(DF3-DF0)       -   VCO  2^N (0 - 1,1 - 2,...,  ;;
;;                        15 - 2^15)                                      ;;
;; 11-0(MF11-MF0)       - ⥫  室  PLL                 ;;
;;                        (  1  4096)                         ;;
;;                                                                          ;;
;;  F(VCO)=MF*F(EXTAL)  -  ࠡ PLL   MF  .   ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        movep   #$0000,x:BCR            ;0 ⠪⮢   
                                        ;譨 饭  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;       BCR ॣ                                                        ;;
;;             +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+            ;;
;;             |15|14|13|12|11|10| 9| 8| 7| 6| 5| 4| 3| 2| 1| 0|            ;;
;;             +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+            ;;
;;               0  0  0  0  0  0  0  0  0  0  0  0  0  0  0  0             ;;
;;                                                                          ;;
;; 15-12 -᫮ ⠪⮢   饭  譥 -(200h-ffc0h);;
;; 11- 8 -᫮ ⠪⮢   饭  譥 Y-(200h-ffc0h);;
;;  7- 4 -᫮ ⠪⮢   饭  譥 P-(f00h-ffffh);;
;;  3- 0 -᫮ ⠪⮢   饭  譥 IO-           ;;
;;  IO  ᯮ  Y -   ᠬ (0xffco-0xffff)  ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        movec   #0,sp                   ;⪠ 㪠⥫ ⥪
        move    #0,omr                  ;䨣஢ -
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   ० 権 OMR                                             ;;
;;  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+                       ;;
;;  |15|14|13|12|11|10| 9| 8| 7| 6| 5| 4| 3| 2| 1| 0|                       ;;
;;  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+                       ;;
;;  |**|**|**|**|**|**|**|**|EA|SD|**|**|**|DE|MB|MA|                       ;;
;;  +-----------------------------------------------+                       ;;
;;  **    - १ࢨ஢                                                 ;;
;;  EA    -   譥                                          ;;
;;  SD    - প  室  STOP ﭨ                           ;;
;;  DE    - ࠧ襭                                             ;;
;;  MB,MA -  䨣樨  ணࠬ                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        move    #$40,r6                 ;⠭ 㪠⥫ ⥪  :$40
        move    #-1,m6                  ; 
        move    #RXBUFFER,x0            ;樠 㪠⥫
        move    x0,x:RXPTR              ;  ਥ
        move    #TXBUFFER,x0            ;樠 㪠⥫
        move    x0,x:TXPTR              ;  ।
        jsr     init_codec              ;室  ணࠬ 樠樨
                                        ;
        jmp     MAIN_PRG

init_codec
        movep   #$0000,x:PCC            ;⠭  室 SSI  SCI
                                        ;  IO 뢮, . .
                                        ;饭 SSI  SCI 䥩ᮢ
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   ஫   (PCC)                                          ;;
;;  +---+---+---+---+---+---+---+---+---+---+---+---+---+----+---+---+      ;;
;;  | 15| 14| 13| 12| 11| 10|  9|  8|  7|  6|  5|  4|  3|   2|  1|  0|      ;;
;;  +---+---+---+---+---+---+---+---+---+---+---+---+---+----+---+---+      ;;
;;  |***|***|***|***|***|***|***|STD|SRD|SCK|SC2|SC1|SC0|SCLK|TXD|RXD|      ;;
;;  +----------------------------------------------------------------+      ;;
;;  ***         - १ࢨ஢                                           ;;
;;  SSI 䥩:                                                          ;;
;;  STD         - SSI ।                                        ;;
;;  SRD         - SSI ਥ                                           ;;
;;  SCK         - SSI clock                                                 ;;
;;  SC2-SC0     -  ஫ ० SSI                                  ;;
;;  SCI 䥩:                                                          ;;
;;  SCLK        - SCI clock                                                 ;;
;;  TXD         - ।                                            ;;
;;  RXD         - ਥ                                               ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        movep   #$4303,x:CRA            ;16 ᫮,. /8, 4 ᫮
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   ஫   SSI (CRA)                                        ;;
;;  +---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+       ;;
;;  | 15| 14| 13| 12| 11| 10|  9|  8|  7|  6|  5|  4|  3|  2|  1|  0|       ;;
;;  +---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+       ;;
;;  |PSR|WL1|WL0|DC4|DC3|DC2|DC1|DC0|PM7|PM6|PM5|PM4|PM3|PM2|PM1|PM0|       ;;
;;  +---------------------------------------------------------------+       ;;
;;  PSR         - ⥫ , 㦥   PM  8(1)  1(0)   ;;
;;  WL1-WL0     -  ᫮   ᫮: 8, 12, 16  24 (00,01,10,11)  ;;
;;  DC4-DC0     - ⥬ ᫥ ᫮  1 (00000)  32 (11111)           ;;
;;  PM7-PM0     -  ⥬ ᫥ ⮢ ⥬  室 ;;
;;                Fosc/2  1(00000000)  256(11111111)                    ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        movep   #$FB30,x:CRB            ;뢠 ࠧ,
                                        ;, clock-.,ᨭ.,
                                        ; ᮢ 1 ,clock-.
                                        ;SC2- 뢮
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   ஫   SSI (CR)                                        ;;
;; +---+---+---+---+---+---+---+----+----+----+----+----+----+----+---+---+ ;;
;; | 15| 14| 13| 12| 11| 10|  9|   8|   7|   6|   5|   4|   3|   2|  1|  0| ;;
;; +---+---+---+---+---+---+---+----+----+----+----+----+----+----+---+---+ ;;
;; |RIE|TIE| RE| TE|MOD|GCK|SYN|FSL1|FSL0|SHFD|SCKD|SCD2|SCD1|SCD0|OF1|OF0| ;;
;; +----------------------------------------------------------------------+ ;;
;; RIE          - ࠧ襭 뢠 ਥ(1)                           ;;
;; TIE          - ࠧ襭 뢠 ।(1)                         ;;
;;  RE          - ࠧ襭 ਥ(1)                                      ;;
;;  TE          - ࠧ襭 ।(1)                                    ;;
;; MOD          - 롮 ० ࠡ SSI 0 - ଠ, 1 -         ;;
;; GCK          - ஫ clock 0 - 뢭, 1 -               ;;
;; SYN          - ᨭ஭(1)/ᨭ஭(0) ஫                     ;;
;; FSL1         -   ᨭ஭樨 RX (1)-1 ,(0)-1 ᫮     ;;
;; FSL0         -   ᨭ஭樨 TX (0)-  RX        ;;
;;                (1) - ⫨筠  RX                                       ;;
;; SHFD         - 冷 ᫥ : (1) - LSB , (0)- SB  ;;
;; SCKD         - clock 筨 (1) - ७, (0) - 譨            ;;
;; SCD2-SCD0    -  ஫ ࠢ SCx (1) - 뢮, (0) -      ;;
;; OF1-OF0      - 䫠 뢮                                              ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        movep   #$14,x:PCDDR            ;⠭ 2  4  뢮
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   ࠢ    (PCDDR)                              ;;
;;  +---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+       ;;
;;  | 15| 14| 13| 12| 11| 10|  9|  8|  7|  6|  5|  4|  3|  2|  1|  0|       ;;
;;  +---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+       ;;
;;  |***|***|***|***|***|***|***| CD| CD| CD| CD| CD| CD| CD| CD| CD|       ;;
;;  +---------------------------------------------------------------+       ;;
;;  CD          - ࠢ    9  PCD (0)- (1)-뢮;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        movep   #$0,x:PCD               ; 0  2  4 : 
                                        ;CS4215  室 CS4215  ஫
                                        ;०
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;      (PCD)                                            ;;
;;  +---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+       ;;
;;  | 15| 14| 13| 12| 11| 10|  9|  8|  7|  6|  5|  4|  3|  2|  1|  0|       ;;
;;  +---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+       ;;
;;  |***|***|***|***|***|***|***| PC| PC| PC| PC| PC| PC| PC| PC| PC|       ;;
;;  +---------------------------------------------------------------+       ;;
;;  PC          -   PCD -    䨣஢  뢮  ;;
;;                 PCD, ⥭ - ⥭   䨣஢    ;;
;;                 ,   । ⤥  SSI     ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        do      #500,_delay_loop        ;প । 樠樥 CS4215
        rep     #2000                   ; 100 
        nop
_delay_loop
        bset    #4,x:PCD                ; 1  4  - 室 CS4215
                                        ; ﭨ 
        movep   #$3000,x:IPR            ;⠭ 㦭 ஢ 뢠
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   ஢ 뢠 (IPR)                                        ;;
;;   +----+----+----+----+----+----+-+-+-+-+----+----+----+----+----+----+  ;;
;;   |  15|  14|  13|  12|  11|  10|9|8|7|6|   5|   4|   3|   2|   1|   0|  ;;
;;   +----+----+----+----+----+----+-+-+-+-+----+----+----+----+----+----+  ;;
;;   |SCL1|SCL0|SSL1|SSL0|HPL1|HPL0|*|*|*|*|IBL2|IBL1|IBL0|IAL2|IAL1|IAL0|  ;;
;;   +-------------------------------------------------------------------+  ;;
;;   SCL1-SCL0  - SCI ஢ 뢠                                    ;;
;;   SSL1-SSL0  - SSI ஢ 뢠                                    ;;
;;   HPL1-HPL0  -  ஢ 뢠                                   ;;
;;   IBL2-IBL0  - ० IRQB                                                ;;
;;   IAL2-IAL0  - ० IRQA                                                ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        andi    #$FC,mr                 ;ࠧ襭 뢠
;*****************************************************************************
;       饭 ஫ ᫮    ।            *
;*****************************************************************************
        move    #CTRL_WD_12,x0          ;
        move            x0,x:TXBUFFER   ;
        move    #CTRL_WD_34,x0          ;
        move            x0,x:TXBUFFER+1 ;
        move    #CTRL_WD_56,x0          ;
        move            x0,x:TXBUFFER+2 ;
        move    #CTRL_WD_78,x0          ;
        move            x0,x:TXBUFFER+3 ;
                                        ;
        movep   #$01E8,x:PCC            ;ࠧ襭 SSI  8,7,6,5,3
        jclr    #3,x:SSISR,*            ;   3(RFS)  㤥
                                        ;ࠢ 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;   ﭨ SSI (SSISR)                                           ;;
;;  +---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+       ;;
;;  | 15| 14| 13| 12| 11| 10|  9|  8|  7|  6|  5|  4|  3|  2|  1|  0|       ;;
;;  +---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+---+       ;;
;;  |***|***|***|***|***|***|***|***|RDF|TDE|ROE|TUE|RFS|TFS|IF1|IF0|       ;;
;;  +---------------------------------------------------------------+       ;;
;;  ***         - १ࢨ஢                                           ;;
;;  RDF         - 䫠  ਥ ॣ                        ;;
;;  TDE         - 䫠 襭 ॣ ।                        ;;
;;  ROE         - 䫠 १  ਥ (訡)                   ;;
;;  TUE         - 䫠 ८襭  । (訡)                ;;
;;  RFS         - FSYNC ਥ                                              ;;
;;  TFS         - FSYNC ।                                            ;;
;;  IF1-IF0     - 室 䫠                                             ;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
        jset    #3,x:SSISR,*            ;   3(RFS)  㤥
                                        ;ࠢ 0
        jclr    #3,x:SSISR,*            ;   3(RFS)  㤥
                                        ;ࠢ 1
        jset    #18,x:RXBUFFER,*        ;   18(CLB)  㤥
                                        ;ࠢ 1
        bset    #18,x:TXBUFFER          ;⥯ CLB   ࠢ 1
        do      #4,_init_loopB          ;4 ࠧ  室  
        jclr    #2,x:SSISR,*            ; TFS -  㢥७, 
        jset    #2,x:SSISR,*            ; ଠ ⨣ 
_init_loopB
        movep   #0,x:PCC                ;᭮   SSI
        movep   #$4303,x:CRA            ;16 ᫮,. /8, 4 ᫮
        movep   #$FB00,x:CRB            ;ࠧ. 뢠, , . clock
                                        ;. clk, ᨭ. ०, 1  FSYNC,
                                        ;MSB 묨, SCx - 
        movep   #$14,x:PCD              ; 1  1  4 
        movep   #$01E8,x:PCC            ;ࠧ襭 3,5,6,7,8  SSI
        rts                             ;樠 祭
;*****************************************************************************
;       楤 ࠡ⪨ 뢠 SSI ।                          *
;*****************************************************************************
ssi_transmit_isr
        move    r0,x:(r6)+              ;࠭ 祭 r0  m0  ⥪
        move    m0,x:(r6)+              ;
        move    #3,m0                   ;⠭ 横.   4 ⮢
        move    x:TXPTR,r0              ;⠭. ⥪饣 ६. ࢠ
        jclr    #2,x:SSISR,next_tx      ;᫨ 襫 TFS, 
        move    #TXBUFFER+1,r0          ;⠭ r0  砫  ।
        nop                             ; 
next_tx
        movep   x:(r0)+,x:SSIDR         ;뢮 ⥪饣 祭  
        move    r0,x:TXPTR              ;࠭ 祭 r0  㪠⥫
        move    x:-(r6),m0              ;⠭ m0
        move    x:-(r6),r0              ; r0
        rti                             ;  뢠

;*****************************************************************************
;       楤 ࠡ⪨ 뢠 SSI ਥ                            *
;*****************************************************************************
ssi_receive_isr
        move    r0,x:(r6)+              ;࠭ 祭 r0  m0  ⥪
        move    m0,x:(r6)+              ;
        move    #3,m0                   ;⠭ 横.   4 ⮢
        move    x:RXPTR,r0              ;⠭. ⥪饣 ६. ࢠ
        jclr    #3,x:SSISR,next_rx      ;᫨ 襫 RFS, 
        move    #RXBUFFER,r0            ;⠭ r0  砫  ਥ
        nop                             ; 
next_rx
        movep   x:SSIDR,x:(r0)+         ;뢮 ⥪饣 祭  
        move    r0,x:RXPTR              ;࠭ 祭 r0  㪠⥫
        move    x:-(r6),m0              ;⠭ m0
        move    x:-(r6),r0              ; r0
        rti                             ;  뢠

