        page    132,60
;****************************************************************************
;       FLTR_TST.ASM
;       Test program for the external memory, analog circuitry, and OnCE
;       Port circuitry of the DSP56002EVM evaluation board
;
;       Copywrite (c) MOTOROLA 1994
;                     Semiconductor Products Sector
;                     Digital Signal Processing Division
;
;****************************************************************************



        include 'initial.asm'
TONE_OUTPUT     EQU     HEADPHONE_EN+LINEOUT_EN+(0*LEFT_ATTN)+(0*RIGHT_ATTN)
NOISE_OUTPUT    EQU     HEADPHONE_EN+LINEOUT_EN
TONE_INPUT      EQU     MIC_IN_SELECT+(15*MONITOR_ATTN)+(4*LEFT_GAIN)+(4*RIGHT_GAIN)
NOISE_INPUT     EQU     MIC_IN_SELECT+(15*MONITOR_ATTN)+(15*LEFT_GAIN)+(15*RIGHT_GAIN)
start           EQU     $60
sinep           EQU     $100
mask            EQU     255
delta           EQU     5
sinea           EQU     $ffe0
delta1          EQU     0.1

        org     p:
MAIN_PRG
noise_ini
        move    #$0,x0
        move    x0,x:TXBUFFER
        move    x0,x:TXBUFFER+1
        move    #NOISE_OUTPUT,x0
        move    x0,x:TXBUFFER+2
        move    #NOISE_INPUT,x0
        move    x0,x:TXBUFFER+3

                movec   #6,omr
        move            #sinep,r1
        movec           #mask,m1
        move            #delta,n1

        move    #delta1,x0

noise_loop1
        jset    #2,x:SSISR,*            ; Wait for frame sync to pass.
        jclr    #2,x:SSISR,*            ; Wait for frame sync.
        nop

        movep           y:(r1)+n1,y:sinea

        move    y:sinea,y0
        mpy     y0,x0,a

        ;move            y:sinea,a


        move    a,x:TXBUFFER
        move    a,x:TXBUFFER+1
        jmp     noise_loop1
